/*
 * Copyright 2004-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.dao.pager;

import javax.servlet.http.HttpServletRequest;

import org.seasar.framework.util.ClassUtil;

/**
 * y[WǗ[eBeBNXB<p>
 * ZbṼy[WIuWFNgǗ܂B<p>
 * <p>
 * gp@͈ȉ̂悤ɂȂ܂B
 * <pre>
 * public class XXXXAction extends Action {
 *   private PagerSupport pager = new Pager(20, MyPagerCondition.class, "myPagerCondition");
 *   private MyLogic logic;
 *   public void setMyLogic(MyLogic logic) {
 *     this.logic = logic;
 *   }
 * 
 *   public ActionForward doExecute(ActionMapping mapping, ActionForm _form,
 *       HttpServletRequest request, HttpServletResponse response) throws Exception {
 * 
 *      // p[^offsetɃy[WoffsetʒuXV
 *      pager.updateOffset(request);
 *      // 
 *  	MyPagerCondition dto = (MyPagerCondition) pager.getPagerCondition(request);
 *       if (form.getCode() != null) {
 *           // ݂΁AZbgB
 *           dto.setCode(form.getCode());
 *       }
 *       List items = logic.getItems(dto);
 *       request.setAttribute("items", items);
 *   }
 * }
 * </pre>
 * @author Toshitaka Agata(Nulab,inc.)
 */
public class PagerSupport {

    /** ő擾̏l */
    public static final int DEFAULT_LIMIT = PagerCondition.NONE_LIMIT;

    /** ő擾 */
    private int limit = DEFAULT_LIMIT;

    /** y[WNX */
    private Class pagerConditionClass;

    /** IuWFNg̃ZbV̖O */
    private String pagerConditionName;

    /**
     * RXgN^<p>
     * ő擾͖(-1)ɐݒ肳܂B
     * @param pagerConditionClass y[WNX
     * @param pagerConditionName IuWFNg̃ZbV̖O
     */
    public PagerSupport(Class pagerConditionClass, String pagerConditionName) {
        this(DEFAULT_LIMIT, pagerConditionClass, pagerConditionName);
    }

    /**
     * RXgN^
     * @param limit ő擾
     * @param pagerConditionClass y[WNX
     * @param pagerConditionName IuWFNg̃ZbV̖O
     */
    public PagerSupport(int limit, Class pagerConditionClass,
            String pagerConditionName) {
        this.limit = limit;
        this.pagerConditionClass = pagerConditionClass;
        this.pagerConditionName = pagerConditionName;
    }

    /**
     * NGXgp[^w肵āAZbV̌IuWFNǧ݈ʒuXV܂B<p>
     * IuWFNg݂ȂꍇAVKɌIuWFNg𐶐܂B
     * @param request HttpServletRequest
     * @param offsetParamName ݈ʒu\NGXgp[^
     */
    public void updateOffset(HttpServletRequest request, String offsetParamName) {
        int offset = getOffset(request, offsetParamName);
        PagerCondition pagerCondition = getPagerCondition(request);
        pagerCondition.setOffset(offset);
    }

    /**
     *  NGXgp[^"offset"ŃZbV̌IuWFNǧ݈ʒuXV܂B<p>
     * IuWFNg݂ȂꍇAVKɌIuWFNg𐶐܂B
     * @param request HttpServletRequest
     */
    public void updateOffset(HttpServletRequest request) {
        updateOffset(request, "offset");
    }

    /**
     * NGXgp[^"offset"猻݈ʒu擾܂B
     * @param request HttpServletRequest
     * @param offsetParamName ݈ʒu\NGXgp[^
     * @return@݈ʒu
     */
    private int getOffset(HttpServletRequest request, String offsetParamName) {
        String value = request.getParameter(offsetParamName);
        if (value == null || value.length() == 0) {
            return 0;
        } else {
            try {
                return Integer.parseInt(value);
            } catch (NumberFormatException e) {
                return 0;
            }
        }
    }

    /**
     * ZbV̌IuWFNg擾܂B<p>
     * IuWFNg݂ȂꍇAVKɌIuWFNg𐶐܂B
     * @param request HttpServletRequest
     * @return IuWFNg
     */
    public PagerCondition getPagerCondition(HttpServletRequest request) {
        PagerCondition dto = (PagerCondition) request.getSession()
                .getAttribute(pagerConditionName);
        if (dto == null) {
            dto = (PagerCondition) ClassUtil.newInstance(pagerConditionClass);
            dto.setLimit(limit);
            request.getSession().setAttribute(pagerConditionName, dto);
        }
        return dto;
    }

}